﻿using System;
using System.IO;
using Android.Content;
using Android.Support.V4.Content;

using FileProviderSample.Droid;
using Java.IO;
using Xamarin.Forms;
using Application = Android.App.Application;
using File = Java.IO.File;

[assembly: Dependency(typeof(SaveAndroid))]
namespace FileProviderSample.Droid
{
    public class SaveAndroid : ISave
    {

        public void Save(string fileName, string contentType, MemoryStream stream)
        {
            string exception = string.Empty;
            string root = null;
            if (Android.OS.Environment.IsExternalStorageEmulated)
            {
                root = Android.OS.Environment.ExternalStorageDirectory.ToString();
            }
            else
                root = Android.App.Application.Context.FilesDir.Path;

            File myDir = new File(root + "/Atas");
            myDir.Mkdir();
            File file = new File(myDir, fileName);
            if (file.Exists())
                file.Delete();
            try
            {
                FileOutputStream outs = new FileOutputStream(file);
                stream.Position = 0;
                outs.Write(stream.ToArray());
                outs.Flush();
                outs.Close();
            }
            catch (Exception e)
            {
                System.Console.WriteLine(e);
            }

            if (file.Exists() && contentType != "application/html")
            {
                string extension = Android.Webkit.MimeTypeMap.GetFileExtensionFromUrl(Android.Net.Uri.FromFile(file).ToString());
                string mimeType = Android.Webkit.MimeTypeMap.Singleton.GetMimeTypeFromExtension(extension);
                Intent intent = new Intent(Intent.ActionView);
                var contentUri = FileProvider.GetUriForFile(Application.Context, Application.Context.PackageName + ".fileprovider", file);
                intent.SetDataAndType(contentUri, mimeType);
                intent.AddFlags(ActivityFlags.GrantReadUriPermission);
                intent.AddFlags(ActivityFlags.NewTask);
                intent.AddFlags(ActivityFlags.ClearTop);
                Application.Context.StartActivity(intent);
            }
        }
    }
}